/**
 * Test case for fromFiles.
 * Runs with mocha.
 */
'use strict'

const fromFiles = require('../lib/modeling/from_files.js')
const Apemandb = require('../lib/apemandb.js')
const assert = require('assert')
const fs = require('fs')

describe('fromFiles', () => {
  let tmpDir = `${__dirname}/../tmp`
  let dbFile = tmpDir + '/testing-from-files-db.db'

  before((done) => {
    done()
  })

  after((done) => {
    setTimeout(() => {
      fs.unlink(dbFile, () => {
        done()
      })
    }, 100) // Wait for flush.
  })

  it('From files', (done) => {
    let db = new Apemandb('testing-from-files-database01', "foo", "bar", {
      dialect: 'sqlite',
      storage: dbFile
    })
    let models = fromFiles(db, __dirname + '/../misc/mocks/models/*.json')
    assert.ok(models)
    done()
  })
})

/* global describe, before, after, it */
